// copyright 2006-2007 Dean Laforet

window.onload = init;

// default settings. they will be overwritten if a settingsFile.txt file exists
var localCode = "ATX";  // set the local area. default ATX=Seattle,WA area
var selectedArea = "178"; // this is Vancouver in the settings drop down list
var server = "http://radar.weather.gov/ridge/";  // default server 
var mapType = "N0R";  // default radar type. N0R=base reflectivity
var mapRange = "Short";  // default radar range. use Short unless using N0Z above then use Long
var radarWidth = "300px";  // DO NOT CHANGE THIS.
var radarHeight = "250px";  // DO NOT CHANGE THIS. If you do you will have to reposition the time overlay.
var radarCropTop = "-100px";  // set from 0 to -330px or change in setting window
var radarCropLeft = "0";  // set from 0 to -300px
var topSelected = "2";  // this preselects -200px in the drop down settings.
var leftSelected = "0";  // this preselects -100px in the drop down settings.
var showCities = "yes";
var showRivers = "yes";
var showCounties = "yes";
var showHighways = "no";
var t = 5; // interval in minutes

var gadgetPath = System.Gadget.path;
var settingsFile = gadgetPath+"\\settingsFile.txt";
var oFSO = new ActiveXObject("Scripting.FileSystemObject");

// radar type functions
function radarN0R() 
{
  mapType = "N0R";
  mapRange = "Short";
  loadImages();
}
function radarNCR() 
{
  mapType = "NCR";
  mapRange = "Short";
  loadImages();
}
function radarN1P() 
{
  mapType = "N1P";
  mapRange = "Short";
  loadImages();
}
function radarN0S() 
{
  mapType = "N0S";
  mapRange = "Short";
  loadImages();
}
function radarN0Z() 
{
  mapType = "N0Z";
  mapRange = "Long";
  loadImages();
}

function loadImages() 
{
  imgTopo = server+ "Overlays/Topo/" +mapRange+ "/" +localCode+ "_Topo_" +mapRange+ ".jpg";
  imgRadar = server+ "RadarImg/" + mapType + "/" + localCode + "_" + mapType + "_0.gif";
  imgCity = server+ "Overlays/Cities/" +mapRange+ "/" +localCode+ "_City_" +mapRange+ ".gif";
  imgCounty = server+ "Overlays/County/" +mapRange+ "/" +localCode+ "_County_" +mapRange+ ".gif";
  imgRivers = server+ "Overlays/Rivers/" +mapRange+ "/" +localCode+ "_Rivers_" +mapRange+ ".gif";
  imgHighways = server+ "Overlays/Highways/" +mapRange+ "/" +localCode+ "_Highways_" +mapRange+ ".gif";
  imgLegend = server+ "Legend/" +mapType+ "/" +localCode+ "_" +mapType+ "_Legend_0.gif";

  document.images["topo"].src = imgTopo;
  if (showRivers=="yes") {document.images["river"].src = imgRivers} else {document.images["river"].src = "img/transparent.png"}
  if (showCounties=="yes") {document.images["county"].src = imgCounty} else {document.images["county"].src = "img/transparent.png"}
  if (showHighways=="yes") {document.images["highway"].src = imgHighways} else {document.images["highway"].src = "img/transparent.png"}
  if (showCities=="yes") {document.images["city"].src = imgCity} else {document.images["city"].src = "img/transparent.png"}

  loadTimer();
}

// function to reload radar images
function loadTimer() 
{
  tmp = new Date();
  tmp = "?"+tmp.getTime();
  document.images["radar"].src = imgRadar+tmp;
  document.images["legend"].src = imgLegend+tmp;
  setTimeout("loadTimer()",t*60000);
}

// change radar size
function sizeIt() 
{
  if (radarWidth=="300px") 
  {
    radarWidth = "600px";
    radarHeight = "580px";
    div1.style.top = "0";
    div1.style.left = "0";
    div2.style.top = "0";
    div2.style.left = "0";
    div3.style.top = "0";
    div3.style.left = "0";
    div4.style.top = "0";
    div4.style.left = "0";
    div5.style.top = "0";
    div5.style.left = "0";
    div6.style.top = "0";
    div6.style.left = "0";
    div7.style.top = "0";
    div7.style.left = "0";
  }
  else 
  {
    radarWidth = "300px";
    radarHeight = "250px";
    setRadarCrop();
  }
  document.body.style.width = radarWidth;
  document.body.style.height = radarHeight;
  loadImages();
}

function setRadarCrop() 
{
  div1.style.top = radarCropTop;
  div1.style.left = radarCropLeft;
  div2.style.top = radarCropTop;
  div2.style.left = radarCropLeft;
  div3.style.top = radarCropTop;
  div3.style.left = radarCropLeft;
  div4.style.top = radarCropTop;
  div4.style.left = radarCropLeft;
  div5.style.top = radarCropTop;
  div5.style.left = radarCropLeft;
  div6.style.top = radarCropTop;
  div6.style.left = radarCropLeft;
  div7.style.top = "200px";
  div7.style.left = "-308px";
}

function setRivers() 
{
  if (showRivers=="yes") 
  {
    showRivers = "no";
    document.images["river"].src = "img/transparent.png";
  }
  else
  {
    showRivers = "yes";
    document.images["river"].src = imgRivers;
  }
}

function setCities() 
{
  if (showCities=="yes") 
  {
    showCities = "no";
    document.images["city"].src = "img/transparent.png";
  }
  else
  {
    showCities = "yes";
    document.images["city"].src = imgCity;
  }
}

function setCounties() 
{
  if (showCounties=="yes") 
  {
    showCounties = "no";
    document.images["county"].src = "img/transparent.png";
  } 
  else
  {
    showCounties = "yes";
    document.images["county"].src = imgCounty;
  }
}

function setHighways() 
{
  if (showHighways=="yes") 
  {
    showHighways = "no";
    document.images["highway"].src = "img/transparent.png";
  } 
  else 
  {
    showHighways = "yes";
    document.images["highway"].src = imgHighways;
  }
}

System.Gadget.docked?dockGadget():unDockGadget();

// check if docked or undocked and adjust.
System.Gadget.onDock = function dockGadget()
{
  document.body.style.width = "130px";
  document.body.style.height = "109px";
  System.Gadget.background = "url(img/docked_bg.png)";
  docked.style.display = "block";
  unDocked.style.display = "none";
}
    

System.Gadget.onUndock = function unDockGadget()
{
  document.body.style.width = "300px";
  document.body.style.height = "250px";
  System.Gadget.background = "url(img/transparent.png)";
  document.location = "radar.html";
}

function SettingsClosed() 
{
  localCode = System.Gadget.Settings.read("localCode");
  radarCropTop = System.Gadget.Settings.read("radarCropTop");
  radarCropLeft = System.Gadget.Settings.read("radarCropLeft");
  selectedArea = System.Gadget.Settings.read("selectedArea");
  topSelected = System.Gadget.Settings.read("topSelected");
  leftSelected = System.Gadget.Settings.read("leftSelected");
  if (radarWidth=="300px") {setRadarCrop();}
  loadImages();
  
  if (oFSO.FileExists(settingsFile))
	{
		oFSO.DeleteFile(settingsFile, true);
	}
	var oFile = oFSO.CreateTextFile(settingsFile, true);
	oFile.WriteLine(localCode);
	oFile.WriteLine(selectedArea);
	oFile.WriteLine(radarCropTop);
	oFile.WriteLine(radarCropLeft);
	oFile.WriteLine(topSelected);
	oFile.WriteLine(leftSelected);
	oFile.Close();
}

function init() 
{
  System.Gadget.settingsUI = "Settings.html";
  System.Gadget.onSettingsClosed = SettingsClosed;

  openSettingsFile();
  
  if (radarWidth=="300px") {setRadarCrop();}
  loadImages();
}

function openSettingsFile()
{
  if (oFSO.FileExists(settingsFile))
	{
    var defaultFile = oFSO.OpenTextFile(settingsFile, 1, false);
	
    if (defaultFile.AtEndOfStream) return;
    localCode = defaultFile.ReadLine();
    System.Gadget.Settings.write("localCode", localCode);
    if (defaultFile.AtEndOfStream) return;
    selectedArea = defaultFile.ReadLine();
    System.Gadget.Settings.write("selectedArea", selectedArea);
    if (defaultFile.AtEndOfStream) return;
    radarCropTop = defaultFile.ReadLine();
    System.Gadget.Settings.write("radarCropTop", radarCropTop);
    if (defaultFile.AtEndOfStream) return;
    radarCropLeft = defaultFile.ReadLine();
    System.Gadget.Settings.write("radarCropLeft", radarCropLeft);
    if (defaultFile.AtEndOfStream) return;
    topSelected = defaultFile.ReadLine();
    System.Gadget.Settings.write("topSelected", topSelected);
    if (defaultFile.AtEndOfStream) return;
    leftSelected = defaultFile.ReadLine();
    System.Gadget.Settings.write("leftSelected", leftSelected);
  
    defaultFile.Close();
  }
}

